﻿// 
// Copyright (c) 2004-2019 Jaroslaw Kowalski <jaak@jkowalski.net>, Kim Christensen, Julian Verdurmen
// 
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without 
// modification, are permitted provided that the following conditions 
// are met:
// 
// * Redistributions of source code must retain the above copyright notice, 
//   this list of conditions and the following disclaimer. 
// 
// * Redistributions in binary form must reproduce the above copyright notice,
//   this list of conditions and the following disclaimer in the documentation
//   and/or other materials provided with the distribution. 
// 
// * Neither the name of Jaroslaw Kowalski nor the names of its 
//   contributors may be used to endorse or promote products derived from this
//   software without specific prior written permission. 
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
// ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
// THE POSSIBILITY OF SUCH DAMAGE.
// 

using System;
using System.Diagnostics;
using System.Diagnostics.CodeAnalysis;
using NLog;
using NLog.Config;
using NLog.Targets;

namespace LoaderTestPublic
{
    public class NLogPackageLoader
    {
        public static void Preload()
        {

        }
    }
}

namespace LoaderTestInternal
{
    /// <summary>
    /// private
    /// </summary>
    internal class NLogPackageLoader
    {
        public static void Preload()
        {

        }
    }
}

namespace LoaderTestPrivateNested
{
    internal class SomeType
    {
        [SuppressMessage("ReSharper", "UnusedMember.Local")]
        private class NLogPackageLoader
        {
            public static void Preload(ConfigurationItemFactory fact)
            {
                if (fact == null)
                {
                    throw new ArgumentNullException(nameof(fact));
                }
            }
        }
    }
}

namespace LoaderTestPrivateNestedStatic
{
    internal class SomeType
    {
        [SuppressMessage("ReSharper", "UnusedMember.Local")]
        private static class NLogPackageLoader
        {
            public static void Preload()
            {

            }
        }
    }
}

namespace LoaderTestWrong1
{
    public class NLogPackageLoader
    {
        [DebuggerStepThrough]
        public static void Preload()
        {
            throw new Exception("ow noos");
        }
    }
}

namespace LoaderTestWrong2
{
    public class NLogPackageLoader
    {
        public void Preload()
        {
            //im not static
        }
    }
}

namespace LoaderTestWrong3
{
    public class NLogPackageLoader
    {
        public static void Preload(int arg1, int arg2)
        {
            //I have args
        }
    }
}